package com.voice.bdv;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

import android.content.Context;

public class UDPWorker implements Runnable {

	DatagramSocket send;
	InetAddress serverAddress;

	DatagramSocket recv;
	Context context;
	RecvListener recvListener;

	String ip;
	int port;
	boolean run;

	/**
	 * ĬϽ
	 * @param context
	 * @param port
	 */
	public UDPWorker(Context context, String port) {
		this.port = Integer.parseInt(port);
		new Thread(this).start();
	}

	/**
	 * ĬǷ
	 * @param context
	 * @param ip
	 * @param port
	 */
	public UDPWorker(Context context, String ip, String port) {
		// TODO Auto-generated constructor stub
		this(context, port);
		this.ip = ip;
		new Thread(this).start();
	}

	byte[] buf = new byte[1024];

	public void setRecvListener(RecvListener recvListener) {
		this.recvListener = recvListener;
	}

	private void recvRun() {
		try {
			InetAddress address = InetAddress.getByName("localhost");
			recv = new DatagramSocket(port, address);
			DatagramPacket packet = new DatagramPacket(buf, buf.length,
					address, port);
			while (run) {
				recv.receive(packet);
				if (recvListener != null)
					recvListener.onRecv(packet.getData(), packet.getOffset(),
							packet.getLength());
			}
		} catch (SocketException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void sendPacket(String text) {
		byte[] data = text.getBytes();
		DatagramPacket packet = new DatagramPacket(data, data.length,
				serverAddress, port);
		try {
			send.send(packet);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void sendMsg(final String text) {
		new Thread() {

			@Override
			public void run() {
				// TODO Auto-generated method stub
				super.run();
				sendPacket(text);//򵥷;ͲϢͶ
			}

		}.start();
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		run = true;
		if (ip == null) {
			// ֻ
			recvRun();
		} else {
			// ֻ
			try {
				send = new DatagramSocket();
				serverAddress = InetAddress.getByName(ip);
			} catch (SocketException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (UnknownHostException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public void close() {
		if (send != null)
			send.close();
		if (recv != null)
			recv.close();
		run = false;
	}

	public static interface RecvListener {
		public void onRecv(byte[] data, int offset, int length);
	}

}
